#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=netshell_193.ico
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Process.au3>
#include <Constants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <_SysTray.au3>
#include '_OsVersionInfo.au3'

If $CmdLine[0] = 0 Then
	If ProcessExists(@ScriptName) Then
		ProcessClose(@ScriptName)
		_RefreshSystemTray()
		_Exit()
	EndIf
EndIf

$execfile = $CmdLine[1]

Opt("TrayMenuMode", 1) ; Default tray menu items (Script Paused/Exit) will not be shown.
Local $exititem = TrayCreateItem("Exit")
TraySetToolTip(StringLeft(@ScriptName, StringLen(@ScriptName) - 4) & @CRLF & "Left-click to execute file and exit" & @CRLF & "Right-click for menu")
TraySetClick(16)
TraySetState()

While 1
	$msg = TrayGetMsg()
	Switch $msg
		Case $TRAY_EVENT_PRIMARYUP, $exititem
			_ExecuteFile()
		Case Else
			ContinueLoop
	EndSwitch
	Sleep(500)
WEnd

Func _Exit()
	Exit
EndFunc

Func _ExecuteFile()
	If StringInStr($execfile, "\") > 0 Then
		$path = StringLeft($execfile, StringInStr($execfile, "\", 0, -1) - 1)
	Else
		$path = "."
	EndIf
	Run(@ComSpec & " /c " & '"' & $CmdLine[1] & '"', $path, @SW_HIDE)
	_Exit()
EndFunc

Func _RefreshSystemTray()  ;--- The magic that clears the SysTray of dead icons courtesy of a UDF by Tuape & Erik Pilsits
	$count = _SysTrayIconCount()
	For $i = $count - 1 To 0 Step -1
		$handle = _SysTrayIconHandle($i)
		$visible = _SysTrayIconVisible($i)
		$pid = WinGetProcess($handle)
		$name = _ProcessGetName($pid)
		$title = WinGetTitle($handle)
		$tooltip = _SysTrayIconTooltip($i)
		If $pid = -1 Then _SysTrayIconRemove($i)
	Next

	If _OsVersionTest($VER_GREATER_EQUAL, 6, 1) Then
		$countwin7 = _SysTrayIconCount(2)
		For $i = $countwin7 - 1 To 0 Step -1
			$handle = _SysTrayIconHandle($i, 2)
			$visible = _SysTrayIconVisible($i, 2)
			$pid = WinGetProcess($handle)
			$name = _ProcessGetName($pid)
			$title = WinGetTitle($handle)
			$tooltip = _SysTrayIconTooltip($i, 2)
			If $pid = -1 Then _SysTrayIconRemove($i, 2)
		Next
	EndIf
EndFunc